import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Monster here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Monster extends BadGuys
{
    int frame = 0;
    private int animationCount;
    private int vSpeed = 0;
    private int acceleration = 2;

    private int spriteHeight = getImage().getHeight();
    private int spriteWidth = getImage().getWidth();
    private int lookForGroundDistance = (int)spriteHeight/2;
    private int lookForEdge = (int)spriteWidth/2;

    private int speed = 1;

    GreenfootImage monster1l = new GreenfootImage("monster1l.png");
    GreenfootImage monster2l = new GreenfootImage("monster2l.png");
    GreenfootImage monster3l = new GreenfootImage("monster3l.png");
    GreenfootImage monster4l = new GreenfootImage("monster4l.png");
    GreenfootImage monster5l = new GreenfootImage("monster5l.png");
    GreenfootImage monster6l = new GreenfootImage("monster6l.png");
;    GreenfootImage monster7l = new GreenfootImage("monster7l.png");
    GreenfootImage monster8l = new GreenfootImage("monster8l.png");
    GreenfootImage monster9l = new GreenfootImage("monster9l.png");
    GreenfootImage monster10l = new GreenfootImage("monster10l.png");
    
    GreenfootImage monster1r = new GreenfootImage("monster1r.png");
    GreenfootImage monster2r = new GreenfootImage("monster2r.png");
    GreenfootImage monster3r = new GreenfootImage("monster3r.png");
    GreenfootImage monster4r = new GreenfootImage("monster4r.png");
    GreenfootImage monster5r = new GreenfootImage("monster5r.png");
    GreenfootImage monster6r = new GreenfootImage("monster6r.png");
    GreenfootImage monster7r = new GreenfootImage("monster7r.png");
    GreenfootImage monster8r = new GreenfootImage("monster8r.png");
    GreenfootImage monster9r = new GreenfootImage("monster9r.png");
    GreenfootImage monster10r = new GreenfootImage("monster10r.png");

    /**
     * Act - do whatever the Monster wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        checkFall();
        move();
        if(speed<0)
        {
            if(animationCount %4 == 0)
                animateLeft();
        }
        else
        {
            if(animationCount % 4 == 0)
                animateRight();
        }
        animationCount ++;
    }    

    public void move()
    {
        Actor ground = getOneObjectAtOffset(lookForEdge, lookForGroundDistance, Platform.class);
        
        if(ground == null)
        {
            speed *= -1; // Reverses direction
            lookForEdge *= -1; // Looks for a negative number
        }
        else
        {
            move(speed);
        }
    }

    public void animateLeft()
    {
        if(frame == 0)
        {
            setImage(monster1l);
        }
        if(frame == 1)
        {
            setImage(monster2l);
        }
        if(frame == 2)
        {
            setImage(monster3l);
        }
        if(frame == 3)
        {
            setImage(monster4l);
        }
        if (frame == 4)
        {
            setImage(monster5l);
        }
        if(frame == 5)
        {
            setImage(monster6l);
        }
        if(frame == 6)
        {
            setImage(monster7l);
            
        }
        if(frame == 7)
        {
            setImage(monster8l);
            
        }
        if(frame == 8)
        {
            setImage(monster9l);
            
        }
        if(frame == 9)
        {
            setImage(monster10l);
            frame = 0;
        }
        frame++;
    }

    public void animateRight()
    {
        if(frame == 0)
        {
            setImage(monster1r);
        }
        if(frame == 1)
        {
            setImage(monster2r);
        }
        if(frame == 2)
        {
            setImage(monster3r);
        }
        if(frame == 3)
        {
            setImage(monster4r);

        }
        if (frame == 4)
        {
            setImage(monster5r);
            
        }
        if(frame == 5)
        {
            setImage(monster6r);
            
        }
        if(frame == 6)
        {
            setImage(monster7r);
            
        }
        if(frame == 7)
        {
            setImage(monster8r);
            
        }
        if(frame == 8)
        {
            setImage(monster9r);
            
        }
        if(frame == 9)
        {
            setImage(monster10r);
            frame = 0;
        }
        frame++;
    }
 public void fall()
    {
        setLocation(getX(), getY() + vSpeed);
        if(vSpeed <=9)
        {
            vSpeed = vSpeed + acceleration;
        }
        
    }
    
    public boolean onGround()
    {
        int spriteHeight = getImage().getHeight();
        int yDistance = (int)(spriteHeight/2) + 5;
        Actor ground = getOneObjectAtOffset(0, getImage().getHeight()/2, Platform.class);
        if(ground == null)
        {
            return false;
        }
        else
        {
            moveToGround(ground);
            return true;
        }
    }
    
    public void moveToGround(Actor ground)
    {
        int groundHeight = ground.getImage().getHeight();
        int newY = ground.getY() - (groundHeight + getImage().getHeight())/2;
        setLocation(getX(), newY);
    }
    
    
    public void checkFall()
    {
        if(onGround())
        {
            vSpeed = 0;
        }
        else
        {
            fall();
        }
    }
    
}